root_window.tk.call('wm','protocol','.','WM_DELETE_WINDOW','destroy .')
#root_window.attributes('-fullscreen', True)
root_window.geometry('1270x900+10+0')

# change the font
root_window.tk.call('.pane.top.feedoverride.l','configure','-font','sans 12')
root_window.tk.call('.pane.top.feedoverride.m','configure','-font','sans 12')
root_window.tk.call('.pane.top.feedoverride.foentry','configure','-font','sans 12')

root_window.tk.call('.pane.top.spinoverride.l','configure','-font','sans 12')
root_window.tk.call('.pane.top.spinoverride.m','configure','-font','sans 12')
root_window.tk.call('.pane.top.spinoverride.foentry','configure','-font','sans 12')

root_window.tk.call('.pane.top.gcodel','configure','-font','sans 12')
root_window.tk.call('.pane.top.gcodel','configure','-foreground','olive')

# hide widgets : use 'grid' or 'pack' depending on how it was originally placed
# only need do top level one
root_window.tk.call('pack','forget','.pane.top.spinoverride.foscale')
root_window.tk.call('pack','forget','.pane.top.feedoverride.foscale')
root_window.tk.call('grid','forget','.pane.top.rapidoverride')
root_window.tk.call('grid','forget','.pane.top.ajogspeed')
root_window.tk.call('grid','forget','.pane.top.jogspeed')
root_window.tk.call('grid','forget','.pane.top.maxvel')
root_window.tk.call('grid','forget','.pane.top.tabs.fmanual.jogf.jog')
root_window.tk.call('pack','forget','.toolbar.rule8')
root_window.tk.call('pack','forget','.toolbar.program_blockdelete')
root_window.tk.call('pack','forget','.toolbar.program_optpause')
root_window.tk.call('grid','forget','.pane.top.tabs.fmanual.coolant')
root_window.tk.call('grid','forget','.pane.top.tabs.fmanual.mist')
root_window.tk.call('grid','forget','.pane.top.tabs.fmanual.flood')

# Configure spindle progress bars
maxvalue = inifile.find('SPINDLE_0','MAX_OUTPUT')
root_window.tk.call('.pane.top.spindlespdf.spindleprogressbar','configure','-maximum',maxvalue)
maxvalue = inifile.find('SPINDLE_1','MAX_OUTPUT')
root_window.tk.call('.pane.top.livetoolf.livetoolprogressbar','configure','-maximum',maxvalue)

# will get called when axis updates
def user_live_update():
	#try:
	set_spindle_display()
	set_livetool_display()
	set_toolchanger_display()
	
	# as button is set on a click, ensure state returns to zero once cmd has been processed
	if (hal.get_value('jntoolchanger.extend-cmd-processed')):
		hal.set_p('jntoolchanger.extend-cmd','0');
	if (hal.get_value('jntoolchanger.continue-cmd-processed')):
		hal.set_p('jntoolchanger.continue-cmd','0');
	if (hal.get_value('jntoolchanger.retract-cmd-processed')):
		hal.set_p('jntoolchanger.retract-cmd','0');
	if (hal.get_value('jntoolchanger.nudge-cmd-processed')):
		hal.set_p('jntoolchanger.nudge-cmd','0');
	
	# am doing this as cannot get access to s.task_paused in jnprogleds component directly
	if (s.task_paused == 1):
		hal.set_p('jnprogleds.status-task-paused','1')
	else:
		hal.set_p('jnprogleds.status-task-paused','0')		
										
	#except:
	#    pass

def set_spindle_display():
	value = int(hal.get_value('spindle-fb-rpm-abs-filtered'));
	root_window.tk.call('.pane.top.spindlespdf.spindleprogressbar','configure','-value',value)
	root_window.tk.call('.pane.top.spindlespdf.spindlespeedl','configure','-text',value)
	if (hal.get_value('spindle.0.at-speed')):
		root_window.tk.call('.pane.top.spindlespdf.spindlel','configure','-foreground','green')
	else:
		root_window.tk.call('.pane.top.spindlespdf.spindlel','configure','-foreground','red')

def set_livetool_display():
	value = int(hal.get_value('spindle1-vel-cmd-rpm'));
	root_window.tk.call('.pane.top.livetoolf.livetoolprogressbar','configure','-value',value)
	root_window.tk.call('.pane.top.livetoolf.livetoolspeedl','configure','-text',value)
	if (hal.get_value('spindle1-at-speed')):
		root_window.tk.call('.pane.top.livetoolf.livetooll','configure','-foreground','green')
	else:
		root_window.tk.call('.pane.top.tlivetoolf.livetooll','configure','-foreground','red')
		
def set_toolchanger_display():
	value = hal.get_value('jntoolchanger.requiredtoolnumberMMI');
	root_window.tk.call('.pane.top.tabs.fmanual.toolchanger.toolnumbervalue','configure','-text',value)
	if (hal.get_value('livetool.spindle-at-speed')):
		root_window.tk.call('.pane.top.tabs.fmanual.toolchanger.pressure1','configure','-foreground','green')
	else:
		root_window.tk.call('.pane.top.tabs.fmanual.toolchanger.pressure1','configure','-foreground','red')	
	# ref error IDs in jntoolchanger.comp		
	value = hal.get_value('jntoolchanger.error-image');
	if (value==0):
		root_window.tk.call('.pane.top.tabs.fmanual.toolchanger.statusl','configure','-text',"NO ERROR")
		root_window.tk.call('.pane.top.tabs.fmanual.toolchanger.statusl','configure','-foreground','green')
	else:
		root_window.tk.call('.pane.top.tabs.fmanual.toolchanger.statusl','configure','-foreground','red')
		if (value==1):
			root_window.tk.call('.pane.top.tabs.fmanual.toolchanger.statusl','configure','-text',"TOOL CHANGER IS EXTENDED")
		elif (value==2):
			root_window.tk.call('.pane.top.tabs.fmanual.toolchanger.statusl','configure','-text',"NUDGE DID NOT GET VALID POS")
		elif (value==3):
			root_window.tk.call('.pane.top.tabs.fmanual.toolchanger.statusl','configure','-text',"POS VALIDATION FAILED")
		elif (value==4):
			root_window.tk.call('.pane.top.tabs.fmanual.toolchanger.statusl','configure','-text',"EXTEND TIMEOUT")
		elif (value==5):
			root_window.tk.call('.pane.top.tabs.fmanual.toolchanger.statusl','configure','-text',"RETRACT TIMEOUT")
		elif (value==6):
			root_window.tk.call('.pane.top.tabs.fmanual.toolchanger.statusl','configure','-text',"POS VALIDITY TIMEOUT")
		elif (value==7):
			root_window.tk.call('.pane.top.tabs.fmanual.toolchanger.statusl','configure','-text',"INVALID STATE")
		elif (value==8):
			root_window.tk.call('.pane.top.tabs.fmanual.toolchanger.statusl','configure','-text',"LOW PRESSURE FAULT")
		else:
			root_window.tk.call('.pane.top.tabs.fmanual.toolchanger.statusl','configure','-text',"FAULT???")


def toolchanger_extend_command():
	hal.set_p('jntoolchanger.extend-cmd','1');
def toolchanger_retract_command():
	hal.set_p('jntoolchanger.retract-cmd','1');
def toolchanger_nudge_command():
	hal.set_p('jntoolchanger.nudge-cmd','1');
def toolchanger_continue_command():
	hal.set_p('jntoolchanger.continue-cmd','1');
	
TclCommands.toolchanger_extend_command = toolchanger_extend_command
TclCommands.toolchanger_retract_command = toolchanger_retract_command
TclCommands.toolchanger_nudge_command = toolchanger_nudge_command
TclCommands.toolchanger_continue_command = toolchanger_continue_command
commands = TclCommands(root_window)

    
